
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit2.Interfaces.PermissionRequest
    ( 

-- * Exported types
    PermissionRequest(..)                   ,
    noPermissionRequest                     ,
    PermissionRequestK                      ,
    toPermissionRequest                     ,


 -- * Methods
-- ** permissionRequestAllow
    permissionRequestAllow                  ,


-- ** permissionRequestDeny
    permissionRequestDeny                   ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit2.Types
import GI.WebKit2.Callbacks
import qualified GI.GObject as GObject

-- interface PermissionRequest 

newtype PermissionRequest = PermissionRequest (ForeignPtr PermissionRequest)
noPermissionRequest :: Maybe PermissionRequest
noPermissionRequest = Nothing

type instance AttributeList PermissionRequest = PermissionRequestAttributeList
type PermissionRequestAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList PermissionRequest = PermissionRequestSignalList
type PermissionRequestSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

foreign import ccall "webkit_permission_request_get_type"
    c_webkit_permission_request_get_type :: IO GType

type instance ParentTypes PermissionRequest = PermissionRequestParentTypes
type PermissionRequestParentTypes = '[GObject.Object]

instance GObject PermissionRequest where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_permission_request_get_type
    

class GObject o => PermissionRequestK o
instance (GObject o, IsDescendantOf PermissionRequest o) => PermissionRequestK o

toPermissionRequest :: PermissionRequestK o => o -> IO PermissionRequest
toPermissionRequest = unsafeCastTo PermissionRequest

-- method PermissionRequest::allow
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2" "PermissionRequest", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2" "PermissionRequest", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_permission_request_allow" webkit_permission_request_allow :: 
    Ptr PermissionRequest ->                -- _obj : TInterface "WebKit2" "PermissionRequest"
    IO ()


permissionRequestAllow ::
    (MonadIO m, PermissionRequestK a) =>
    a ->                                    -- _obj
    m ()
permissionRequestAllow _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_permission_request_allow _obj'
    touchManagedPtr _obj
    return ()

-- method PermissionRequest::deny
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2" "PermissionRequest", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2" "PermissionRequest", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_permission_request_deny" webkit_permission_request_deny :: 
    Ptr PermissionRequest ->                -- _obj : TInterface "WebKit2" "PermissionRequest"
    IO ()


permissionRequestDeny ::
    (MonadIO m, PermissionRequestK a) =>
    a ->                                    -- _obj
    m ()
permissionRequestDeny _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_permission_request_deny _obj'
    touchManagedPtr _obj
    return ()


