
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit2.Objects.FormSubmissionRequest
    ( 

-- * Exported types
    FormSubmissionRequest(..)               ,
    FormSubmissionRequestK                  ,
    toFormSubmissionRequest                 ,
    noFormSubmissionRequest                 ,


 -- * Methods
-- ** formSubmissionRequestGetTextFields
    formSubmissionRequestGetTextFields      ,


-- ** formSubmissionRequestSubmit
    formSubmissionRequestSubmit             ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit2.Types
import GI.WebKit2.Callbacks
import qualified GI.GObject as GObject

newtype FormSubmissionRequest = FormSubmissionRequest (ForeignPtr FormSubmissionRequest)
foreign import ccall "webkit_form_submission_request_get_type"
    c_webkit_form_submission_request_get_type :: IO GType

type instance ParentTypes FormSubmissionRequest = FormSubmissionRequestParentTypes
type FormSubmissionRequestParentTypes = '[GObject.Object]

instance GObject FormSubmissionRequest where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_form_submission_request_get_type
    

class GObject o => FormSubmissionRequestK o
instance (GObject o, IsDescendantOf FormSubmissionRequest o) => FormSubmissionRequestK o

toFormSubmissionRequest :: FormSubmissionRequestK o => o -> IO FormSubmissionRequest
toFormSubmissionRequest = unsafeCastTo FormSubmissionRequest

noFormSubmissionRequest :: Maybe FormSubmissionRequest
noFormSubmissionRequest = Nothing

type instance AttributeList FormSubmissionRequest = FormSubmissionRequestAttributeList
type FormSubmissionRequestAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList FormSubmissionRequest = FormSubmissionRequestSignalList
type FormSubmissionRequestSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method FormSubmissionRequest::get_text_fields
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2" "FormSubmissionRequest", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2" "FormSubmissionRequest", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TGHash (TBasicType TVoid) (TBasicType TVoid)
-- throws : False
-- Skip return : False

foreign import ccall "webkit_form_submission_request_get_text_fields" webkit_form_submission_request_get_text_fields :: 
    Ptr FormSubmissionRequest ->            -- _obj : TInterface "WebKit2" "FormSubmissionRequest"
    IO (Ptr (GHashTable (Ptr ()) (Ptr ())))


formSubmissionRequestGetTextFields ::
    (MonadIO m, FormSubmissionRequestK a) =>
    a ->                                    -- _obj
    m (Map.Map (Ptr ()) (Ptr ()))
formSubmissionRequestGetTextFields _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_form_submission_request_get_text_fields _obj'
    checkUnexpectedReturnNULL "webkit_form_submission_request_get_text_fields" result
    result' <- unpackGHashTable result
    let result'' = mapFirst ptrUnpackPtr result'
    let result''' = mapSecond ptrUnpackPtr result''
    let result'''' = Map.fromList result'''
    touchManagedPtr _obj
    return result''''

-- method FormSubmissionRequest::submit
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2" "FormSubmissionRequest", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2" "FormSubmissionRequest", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_form_submission_request_submit" webkit_form_submission_request_submit :: 
    Ptr FormSubmissionRequest ->            -- _obj : TInterface "WebKit2" "FormSubmissionRequest"
    IO ()


formSubmissionRequestSubmit ::
    (MonadIO m, FormSubmissionRequestK a) =>
    a ->                                    -- _obj
    m ()
formSubmissionRequestSubmit _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_form_submission_request_submit _obj'
    touchManagedPtr _obj
    return ()


